

.include 	"m32def.inc"		;  ATMega32


.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;   /  SREG
.def	Temp5=R21 			;    (    )
.def	Temp6=R22			;    	(   )		
.def	Temp7=R23			;   		
.def	Temp8=R24
.def	Temp9=R25


.dseg					; 

OZU: .byte 6				;  2   



;******************************************************************************

.equ	ADC_ADMUX = (0<<MUX0)

.equ	ADC_ADCSRA = (1<<ADEN)|(1<<ADSC)|(1<<ADIE)|(7<<ADPS0)

.EQU	Constanta_1=0x3E8 			; 1000

.EQU	Constanta_2=0x258 			; 600

;******************************************************************************

.cseg	


		

.org 0					; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset

rjmp RESET				



.org   OC1Aaddr				; Timer/Counter1 Compare Match A

rjmp OCR1A_COMP




.org ADCCaddr				; ADC Conversion Complete

rjmp ADC_Conversion




.org INT_VECTORS_SIZE			;   


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;

	
	ldi Temp,0b00000000		;   "A" (0-, 1-)
	out DDRA,Temp			; 0000000x - ""  PA0
					; 000000x0 - ""  PA1
					; 00000x00 - ""  PA2
				



	RCALL	LCD_INIT		;  




; _______________________________________________________________________________________________________________

	ldi Temp,(0<<MUX0)		
	out ADMUX,Temp	
					; REFS0=0 /   5V /
					; ADLAR=0 /   ( 8     2    )
					; MUX0=0  /    ADC0 (PA0)
					; MUX1=0 
					; MUX2=0 
					; MUX3=0 		
					; MUX4=0

	

	ldi Temp, (1<<ADEN)|(1<<ADSC)|(1<<ADIE)|(7<<ADPS0)
	out ADCSRA,Temp
					; ADEN=1  /  
					; ADSC=1  /   
					; ADATE=0 /   
					; ADIF=0  /      
					; ADIE=1  /    
					; ADPS2=1
					; ADPS1=1
					; ADPS0=1 /   1/128 ( 16  / 128 = 125  )



;	ldi Temp, (0<<ADTS0)
;	out SFIOR,Temp


					; PUD=0 /   ,     //  
					; PSR10=0 /   _1 //  
					; PSR2=0 /   _2 //  
					; ACME=0  /       //   .
					; ADTS2=0
					; ADTS1=0
					; ADTS0=0 /    
					; (       ) //   .

;________________________________________________________________________________________________________________

	




	ldi Temp5, 0			; __0 



	sei				;   
	


;*******************************************************************************************************************************
;  
;*******************************************************************************************************************************

Main:							;  


loop_wait:						;    

	cpi Temp5, 3					;     ?
	brne loop_wait					;  ,  




;     ,   


	ldi Temp,(1<<COM1A1)|(1<<COM1A0)|(1<<FOC1A)	;     "B",    "OC1A"
	out TCCR1A,Temp					;     OC1A ( _1 )!!!

							; COM1A1 /   OC1A //    
							; COM1A0 /   OC1A // (   )
							; COM1B1 /   OC1B 
							; COM1B0 /   OC1B 
							; FOC1A=1 /     OC1A
							; FOC1B=0 /     OC1B // 
							; WGM11=0 / 
							; WGM10=0 / 


	ldi Temp,(0<<COM1A1)|(1<<COM1A0)|(0<<FOC1A)	;    OC1A
	out TCCR1A,Temp					;      OC1A

							; COM1A1 /   OC1A
							; COM1A0 /   OC1A //   
							; COM1B1 /   OC1B 
							; COM1B0 /   OC1B
							; FOC1A=0 /     OC1A // 
							; FOC1B=0 /     OC1B // 
							; WGM11=0 / 
							; WGM10=0 / 


	ldi Temp,(1<<WGM12)|(1<<cs11)			;   "CTC"  
	out TCCR1B,Temp					;     = CK 1:8 
							;   !!!

							; ICNC1=0 / 
							; ICES1=0 / 
							; WGM13=0
							; WGM12=1 /   "CTC"
							; CS12
							; CS11=1 /   = CK 1:8 (16/8=2) 1   = 0,5 
							; CS10 



	ldi Temp,(1<<OCIE1A)				;    
	out TIMSK,Temp


 	ld YL, 0xFF					;   0xFFFF,      ;)
 	ld YH, 0xFF					; 



	OUT OCR1AH, YH					;    
	OUT OCR1AL, YL 					; 
    

	ldi Temp,0					;   
	out TCNT1H,Temp
	out TCNT1L,Temp




	ldi Temp6, 0					;    (   )

	ldi Temp7, 3					;     (      )


loop_wait_2:						;   PPM

	cpi Temp6, 5					;   ???
	brne loop_wait_2				;  ,  


	Rjmp Main

;*******************************************************************************************************************************
;   
;*******************************************************************************************************************************



ADC_Conversion:				;       



	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4


                      
	LDI ZL, low (OZU)		;   "Z"   "OZU" (  16-  )
	LDI ZH, high(OZU)


	IN temp, ADCL			;     
	ST Z+, temp			;    Temp      "Z" 
	IN temp, ADCH			;
	ST Z+, temp			;



	INC Temp5			;    ADC  


	CPI Temp5, 3			;   3 ?
	BREQ ADC_CONV_EXIT		;  ,  



;                  

	LDI Temp, ADC_ADMUX
	OR Temp, Temp5      		;      
	OUT ADMUX, Temp			;   



;     
   
	LDI R16, ADC_ADCSRA
	OUT ADCSRA, R16




ADC_CONV_EXIT:				; 
   
	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4



	RETI				;   






;*******************************************************************************************************************************
;   
;*******************************************************************************************************************************

OCR1A_COMP:



	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4




	CPI Temp6, 0
	BREQ transmitt_pause_0		;    

	CPI Temp6, 1
	BREQ transmitt_kanal_0		;   0- 


	CPI Temp6, 2
	BREQ transmitt_kanal_1		;   1- 


	CPI Temp6, 3
	BREQ transmitt_kanal_2		;   2- 


	CPI Temp6, 4
	BREQ transmitt_sinhro		;   






; *********************************************************

transmitt_pause_0:


 	ld YL, Low(Constanta_2)				;   600
 	ld YH, High(Constanta_2)

	OUT OCR1AH, YH					;    
	OUT OCR1AL, YL 					; 



	CPI Temp7, 3					;    (     )
	BREQ pause_0					;   _0

	CPI Temp7, 0					; _0  
	BREQ pause_1					;   _1
	
	CPI Temp7, 1					; _1  
	BREQ pause_2					;   _2

	CPI Temp7, 2					; _2  
	BREQ pause_Sinhro				;   



pause_0:

	ldi Temp6, 1					;     _0
	rjmp_OCR1A_COMP_EXIT				;    


pause_1:

	ldi Temp6, 2					;     _1
	rjmp_OCR1A_COMP_EXIT				;    


pause_2:

	ldi Temp6, 3					;     _2
	rjmp_OCR1A_COMP_EXIT				;    


pause_Sinhro:

	ldi Temp6, 4					;     
	rjmp_OCR1A_COMP_EXIT				;    


;_0 *********************************************************

transmitt_kanal_0:					;   


	LDI ZL, low (OZU)				;   "Z"   "OZU" (  16-  )
	LDI ZH, high(OZU)


 	ld YL, Z+					;   "YL"       "Z",      "Z" 
 	ld YH, Z					;   "YH"       "Z",


; +1000 

	add YL,Low(Constanta_1)				;  +1000
	adc YH,high(Constanta_1)			;


; *2

	LSL YL						;    16-   (    )
	ROL YH						;




; -600 

	SUB YL, Low(Constanta_2)			; -600  ( )
	SBC YH, high(Constanta_2)			;


	OUT OCR1AH, YH					;    
	OUT OCR1AL, YL 					; 
    


	ldi Temp6, 0					;      (   )

	ldi Temp7, 0					;    _0

	rjmp_OCR1A_COMP_EXIT				;    






;_1 *********************************************************

transmitt_kanal_1:					;  _1


	LDI ZL, low (OZU+2)				;   "Z"   "OZU" (  16-  )
	LDI ZH, high(OZU+2)


 	ld YL, Z+					;   "YL"       "Z",      "Z" 
 	ld YH, Z					;   "YH"       "Z",


; +1000 

	add YL,Low(Constanta_1)				;  +1000
	adc YH,high(Constanta_1)			;


; *2

	LSL YL						;    16-   (    )
	ROL YH						;




; -600 

	SUB YL, Low(Constanta_2)			; -600  ( )
	SBC YH, high(Constanta_2)			;


	OUT OCR1AH, YH					;    
	OUT OCR1AL, YL 					; 
    


	ldi Temp6, 0					;      (   )

	ldi Temp7, 1					;    _1

	rjmp_OCR1A_COMP_EXIT				;    



;_2 *********************************************************

transmitt_kanal_2:					;  _2


	LDI ZL, low (OZU+4)				;   "Z"   "OZU" (  16-  )
	LDI ZH, high(OZU+4)


 	ld YL, Z+					;   "YL"       "Z",      "Z" 
 	ld YH, Z					;   "YH"       "Z",


; +1000 

	add YL,Low(Constanta_1)				;  +1000
	adc YH,high(Constanta_1)			;


; *2

	LSL YL						;    16-   (    )
	ROL YH						;




; -600 

	SUB YL, Low(Constanta_2)			; -600  ( )
	SBC YH, high(Constanta_2)			;


	OUT OCR1AH, YH					;    
	OUT OCR1AL, YL 					; 
    


	ldi Temp6, 0					;      (   )

	ldi Temp7, 2					;    _2

	rjmp_OCR1A_COMP_EXIT				;    




;  *********************************************************

;     

; -600 

	SUB YL, Low(Constanta_2)			; -600  ( )
	SBC YH, high(Constanta_2)			;


	OUT OCR1AH, YH					;    
	OUT OCR1AL, YL 					; 
    

	ldi Temp6, 5					;  !!!!    

	rjmp_OCR1A_COMP_EXIT				;    


;******************************************************

OCR1A_COMP_EXIT:			; 
   
	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4



	RETI				;   


;*******************************************************************************************************************************
; ***
;*******************************************************************************************************************************



